You are viewing a plain text version of this content. The canonical link for it is here.
Posted to commits@kyuubi.apache.org by ch...@apache.org on 2023/05/17 14:33:53 UTC

[kyuubi-shaded] branch master updated: [KYUUBI-SHADED #9] Add scripts for Apache release

This is an automated email from the ASF dual-hosted git repository.

chengpan pushed a commit to branch master
in repository https://gitbox.apache.org/repos/asf/kyuubi-shaded.git


The following commit(s) were added to refs/heads/master by this push:
     new fc69f88  [KYUUBI-SHADED #9] Add scripts for Apache release
fc69f88 is described below

commit fc69f8862b981188f176201a534abd750f292cc2
Author: Cheng Pan <ch...@apache.org>
AuthorDate: Wed May 17 22:33:45 2023 +0800

    [KYUUBI-SHADED #9] Add scripts for Apache release
    
    ### _Why are the changes needed?_
    
    It's required for Apache Release. Notes, the source artifacts are enforced by Apache policy, and we don't need to publish binary artifacts, in addition, we should deploy the jar to the maven central.
    
    ### _How was this patch tested?_
    - [ ] Add some test cases that check the changes thoroughly including negative and positive cases if possible
    
    - [ ] Add screenshots for manual tests if appropriate
    
    - [ ] [Run test](https://kyuubi.readthedocs.io/en/master/develop_tools/testing.html#running-tests) locally before make a pull request
    
    Closes #9 from pan3793/apache-release.
    
    f9ed1fb [Cheng Pan] nit
    d6b4534 [Cheng Pan] Add scripts for Apache release
    
    Authored-by: Cheng Pan <ch...@apache.org>
    Signed-off-by: Cheng Pan <ch...@apache.org>
---
 .gitattributes                                 |  24 +++
 LICENSE                                        | 201 +++++++++++++++++++++++++
 NOTICE                                         |   7 +
 build/release/create-package.sh                |  73 +++++++++
 build/release/release.sh                       | 123 +++++++++++++++
 build/release/script/announce.sh               |  68 +++++++++
 build/release/script/dev_kyuubi_vote.sh        | 116 ++++++++++++++
 build/release/tmpl/dev_kyuubi_cancel_vote.tmpl |  29 ++++
 build/release/tmpl/dev_kyuubi_vote_result.tmpl |  43 ++++++
 9 files changed, 684 insertions(+)

diff --git a/.gitattributes b/.gitattributes
new file mode 100644
index 0000000..e608c6d
--- /dev/null
+++ b/.gitattributes
@@ -0,0 +1,24 @@
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+.github/ export-ignore
+.idea/ export-ignore
+*.bat text eol=crlf
+*.cmd text eol=crlf
+*.java text eol=lf
+*.xml text eol=lf
+*.py text eol=lf
diff --git a/LICENSE b/LICENSE
new file mode 100644
index 0000000..261eeb9
--- /dev/null
+++ b/LICENSE
@@ -0,0 +1,201 @@
+                                 Apache License
+                           Version 2.0, January 2004
+                        http://www.apache.org/licenses/
+
+   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
+
+   1. Definitions.
+
+      "License" shall mean the terms and conditions for use, reproduction,
+      and distribution as defined by Sections 1 through 9 of this document.
+
+      "Licensor" shall mean the copyright owner or entity authorized by
+      the copyright owner that is granting the License.
+
+      "Legal Entity" shall mean the union of the acting entity and all
+      other entities that control, are controlled by, or are under common
+      control with that entity. For the purposes of this definition,
+      "control" means (i) the power, direct or indirect, to cause the
+      direction or management of such entity, whether by contract or
+      otherwise, or (ii) ownership of fifty percent (50%) or more of the
+      outstanding shares, or (iii) beneficial ownership of such entity.
+
+      "You" (or "Your") shall mean an individual or Legal Entity
+      exercising permissions granted by this License.
+
+      "Source" form shall mean the preferred form for making modifications,
+      including but not limited to software source code, documentation
+      source, and configuration files.
+
+      "Object" form shall mean any form resulting from mechanical
+      transformation or translation of a Source form, including but
+      not limited to compiled object code, generated documentation,
+      and conversions to other media types.
+
+      "Work" shall mean the work of authorship, whether in Source or
+      Object form, made available under the License, as indicated by a
+      copyright notice that is included in or attached to the work
+      (an example is provided in the Appendix below).
+
+      "Derivative Works" shall mean any work, whether in Source or Object
+      form, that is based on (or derived from) the Work and for which the
+      editorial revisions, annotations, elaborations, or other modifications
+      represent, as a whole, an original work of authorship. For the purposes
+      of this License, Derivative Works shall not include works that remain
+      separable from, or merely link (or bind by name) to the interfaces of,
+      the Work and Derivative Works thereof.
+
+      "Contribution" shall mean any work of authorship, including
+      the original version of the Work and any modifications or additions
+      to that Work or Derivative Works thereof, that is intentionally
+      submitted to Licensor for inclusion in the Work by the copyright owner
+      or by an individual or Legal Entity authorized to submit on behalf of
+      the copyright owner. For the purposes of this definition, "submitted"
+      means any form of electronic, verbal, or written communication sent
+      to the Licensor or its representatives, including but not limited to
+      communication on electronic mailing lists, source code control systems,
+      and issue tracking systems that are managed by, or on behalf of, the
+      Licensor for the purpose of discussing and improving the Work, but
+      excluding communication that is conspicuously marked or otherwise
+      designated in writing by the copyright owner as "Not a Contribution."
+
+      "Contributor" shall mean Licensor and any individual or Legal Entity
+      on behalf of whom a Contribution has been received by Licensor and
+      subsequently incorporated within the Work.
+
+   2. Grant of Copyright License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      copyright license to reproduce, prepare Derivative Works of,
+      publicly display, publicly perform, sublicense, and distribute the
+      Work and such Derivative Works in Source or Object form.
+
+   3. Grant of Patent License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      (except as stated in this section) patent license to make, have made,
+      use, offer to sell, sell, import, and otherwise transfer the Work,
+      where such license applies only to those patent claims licensable
+      by such Contributor that are necessarily infringed by their
+      Contribution(s) alone or by combination of their Contribution(s)
+      with the Work to which such Contribution(s) was submitted. If You
+      institute patent litigation against any entity (including a
+      cross-claim or counterclaim in a lawsuit) alleging that the Work
+      or a Contribution incorporated within the Work constitutes direct
+      or contributory patent infringement, then any patent licenses
+      granted to You under this License for that Work shall terminate
+      as of the date such litigation is filed.
+
+   4. Redistribution. You may reproduce and distribute copies of the
+      Work or Derivative Works thereof in any medium, with or without
+      modifications, and in Source or Object form, provided that You
+      meet the following conditions:
+
+      (a) You must give any other recipients of the Work or
+          Derivative Works a copy of this License; and
+
+      (b) You must cause any modified files to carry prominent notices
+          stating that You changed the files; and
+
+      (c) You must retain, in the Source form of any Derivative Works
+          that You distribute, all copyright, patent, trademark, and
+          attribution notices from the Source form of the Work,
+          excluding those notices that do not pertain to any part of
+          the Derivative Works; and
+
+      (d) If the Work includes a "NOTICE" text file as part of its
+          distribution, then any Derivative Works that You distribute must
+          include a readable copy of the attribution notices contained
+          within such NOTICE file, excluding those notices that do not
+          pertain to any part of the Derivative Works, in at least one
+          of the following places: within a NOTICE text file distributed
+          as part of the Derivative Works; within the Source form or
+          documentation, if provided along with the Derivative Works; or,
+          within a display generated by the Derivative Works, if and
+          wherever such third-party notices normally appear. The contents
+          of the NOTICE file are for informational purposes only and
+          do not modify the License. You may add Your own attribution
+          notices within Derivative Works that You distribute, alongside
+          or as an addendum to the NOTICE text from the Work, provided
+          that such additional attribution notices cannot be construed
+          as modifying the License.
+
+      You may add Your own copyright statement to Your modifications and
+      may provide additional or different license terms and conditions
+      for use, reproduction, or distribution of Your modifications, or
+      for any such Derivative Works as a whole, provided Your use,
+      reproduction, and distribution of the Work otherwise complies with
+      the conditions stated in this License.
+
+   5. Submission of Contributions. Unless You explicitly state otherwise,
+      any Contribution intentionally submitted for inclusion in the Work
+      by You to the Licensor shall be under the terms and conditions of
+      this License, without any additional terms or conditions.
+      Notwithstanding the above, nothing herein shall supersede or modify
+      the terms of any separate license agreement you may have executed
+      with Licensor regarding such Contributions.
+
+   6. Trademarks. This License does not grant permission to use the trade
+      names, trademarks, service marks, or product names of the Licensor,
+      except as required for reasonable and customary use in describing the
+      origin of the Work and reproducing the content of the NOTICE file.
+
+   7. Disclaimer of Warranty. Unless required by applicable law or
+      agreed to in writing, Licensor provides the Work (and each
+      Contributor provides its Contributions) on an "AS IS" BASIS,
+      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+      implied, including, without limitation, any warranties or conditions
+      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
+      PARTICULAR PURPOSE. You are solely responsible for determining the
+      appropriateness of using or redistributing the Work and assume any
+      risks associated with Your exercise of permissions under this License.
+
+   8. Limitation of Liability. In no event and under no legal theory,
+      whether in tort (including negligence), contract, or otherwise,
+      unless required by applicable law (such as deliberate and grossly
+      negligent acts) or agreed to in writing, shall any Contributor be
+      liable to You for damages, including any direct, indirect, special,
+      incidental, or consequential damages of any character arising as a
+      result of this License or out of the use or inability to use the
+      Work (including but not limited to damages for loss of goodwill,
+      work stoppage, computer failure or malfunction, or any and all
+      other commercial damages or losses), even if such Contributor
+      has been advised of the possibility of such damages.
+
+   9. Accepting Warranty or Additional Liability. While redistributing
+      the Work or Derivative Works thereof, You may choose to offer,
+      and charge a fee for, acceptance of support, warranty, indemnity,
+      or other liability obligations and/or rights consistent with this
+      License. However, in accepting such obligations, You may act only
+      on Your own behalf and on Your sole responsibility, not on behalf
+      of any other Contributor, and only if You agree to indemnify,
+      defend, and hold each Contributor harmless for any liability
+      incurred by, or claims asserted against, such Contributor by reason
+      of your accepting any such warranty or additional liability.
+
+   END OF TERMS AND CONDITIONS
+
+   APPENDIX: How to apply the Apache License to your work.
+
+      To apply the Apache License to your work, attach the following
+      boilerplate notice, with the fields enclosed by brackets "[]"
+      replaced with your own identifying information. (Don't include
+      the brackets!)  The text should be enclosed in the appropriate
+      comment syntax for the file format. We also recommend that a
+      file or class name and description of purpose be included on the
+      same "printed page" as the copyright notice for easier
+      identification within third-party archives.
+
+   Copyright [yyyy] [name of copyright owner]
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
diff --git a/NOTICE b/NOTICE
new file mode 100644
index 0000000..3e037c7
--- /dev/null
+++ b/NOTICE
@@ -0,0 +1,7 @@
+
+Apache Kyuubi Shaded
+Copyright 2023 The Apache Software Foundation.
+
+This product includes software developed at
+The Apache Software Foundation (https://www.apache.org/).
+
diff --git a/build/release/create-package.sh b/build/release/create-package.sh
new file mode 100755
index 0000000..04b0a24
--- /dev/null
+++ b/build/release/create-package.sh
@@ -0,0 +1,73 @@
+#!/usr/bin/env bash
+
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+set -o pipefail
+set -e
+set -x
+
+SKIP_GPG=${SKIP_GPG:-false}
+RELEASE_VERSION=${RELEASE_VERSION:?"RELEASE_VERSION is required"}
+
+exit_with_usage() {
+  local NAME=$(basename $0)
+  cat << EOF
+Usage: $NAME <source>
+
+Top level targets are:
+  source: Create source release tarball
+
+All other inputs are environment variables:
+
+RELEASE_VERSION - Release version, must match pom.xml (e.g. 0.1.0)
+SKIP_GPG        - (optional) Default false
+EOF
+  exit 1
+}
+
+KYUUBI_DIR="$(cd "$(dirname "$0")"/../..; pwd)"
+RELEASE_DIR="${KYUUBI_DIR}/work/release"
+
+SHASUM="sha512sum"
+if [ "$(uname)" == "Darwin" ]; then
+    SHASUM="shasum -a 512"
+fi
+
+package_source() {
+  SRC_TGZ_FILE="apache-kyuubi-shaded-${RELEASE_VERSION}-source.tgz"
+  SRC_TGZ="${RELEASE_DIR}/${SRC_TGZ_FILE}"
+
+  mkdir -p "${RELEASE_DIR}"
+  rm -f "${SRC_TGZ}*"
+
+  echo "Creating source release tarball ${SRC_TGZ_FILE}"
+
+  git archive --prefix="apache-kyuubi-shaded-${RELEASE_VERSION}-source/" -o "${SRC_TGZ}" HEAD
+
+  if [ "$SKIP_GPG" == "false" ] ; then
+    gpg --armor --detach-sig "${SRC_TGZ}"
+  fi
+  (cd "${RELEASE_DIR}" && $SHASUM "${SRC_TGZ_FILE}" > "${SRC_TGZ_FILE}.sha512")
+}
+
+if [[ "$1" == "source" ]]; then
+  package_source
+  exit 0
+fi
+
+exit_with_usage
diff --git a/build/release/release.sh b/build/release/release.sh
new file mode 100755
index 0000000..40965ce
--- /dev/null
+++ b/build/release/release.sh
@@ -0,0 +1,123 @@
+#!/usr/bin/env bash
+
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+set -o pipefail
+set -e
+set -x
+
+ASF_USERNAME=${ASF_USERNAME:?"ASF_USERNAME is required"}
+ASF_PASSWORD=${ASF_PASSWORD:?"ASF_PASSWORD is required"}
+RELEASE_VERSION=${RELEASE_VERSION:?"RELEASE_VERSION is required, e.g. 0.1.0"}
+RELEASE_RC_NO=${RELEASE_RC_NO:?"RELEASE_RC_NO is required, e.g. 0"}
+
+exit_with_usage() {
+  local NAME=$(basename $0)
+  cat << EOF
+Usage: $NAME <publish|finalize>
+
+Top level targets are:
+  publish: Publish tarballs to SVN staging repository and jars to Nexus staging repository
+  finalize: Finalize the release after an RC passes vote
+
+All other inputs are environment variables
+
+RELEASE_VERSION - Release version, must match pom.xml and not be SNAPSHOT (e.g. 0.1.0)
+RELEASE_RC_NO   - Release RC number, (e.g. 0)
+
+ASF_USERNAME - Username of ASF committer account
+ASF_PASSWORD - Password of ASF committer account
+EOF
+  exit 1
+}
+
+if [[ ${RELEASE_VERSION} =~ .*-SNAPSHOT ]]; then
+  echo "Can not release a SNAPSHOT version: ${RELEASE_VERSION}"
+  exit_with_usage
+  exit 1
+fi
+
+RELEASE_TAG="v${RELEASE_VERSION}-rc${RELEASE_RC_NO}"
+
+SVN_STAGING_REPO="https://dist.apache.org/repos/dist/dev/kyuubi"
+SVN_RELEASE_REPO="https://dist.apache.org/repos/dist/release/kyuubi"
+
+KYUUBI_DIR="$(cd "$(dirname "$0")"/../..; pwd)"
+RELEASE_DIR="${KYUUBI_DIR}/work/release"
+SVN_STAGING_DIR="${KYUUBI_DIR}/work/svn-dev"
+SVN_RELEASE_DIR="${KYUUBI_DIR}/work/svn-release"
+
+package() {
+  SKIP_GPG="false" RELEASE_VERSION="${RELEASE_VERSION}" $KYUUBI_DIR/build/release/create-package.sh source
+}
+
+upload_svn_staging() {
+  svn checkout --depth=empty "${SVN_STAGING_REPO}" "${SVN_STAGING_DIR}"
+  mkdir -p "${SVN_STAGING_DIR}/kyuubi-shaded-${RELEASE_TAG}"
+  rm -f "${SVN_STAGING_DIR}/kyuubi-shaded-${RELEASE_TAG}/*"
+
+  SRC_TGZ_FILE="apache-kyuubi-shaded-${RELEASE_VERSION}-source.tgz"
+
+  echo "Copying release tarballs"
+  cp "${RELEASE_DIR}/${SRC_TGZ_FILE}"        "${SVN_STAGING_DIR}/kyuubi-shaded-${RELEASE_TAG}/${SRC_TGZ_FILE}"
+  cp "${RELEASE_DIR}/${SRC_TGZ_FILE}.asc"    "${SVN_STAGING_DIR}/kyuubi-shaded-${RELEASE_TAG}/${SRC_TGZ_FILE}.asc"
+  cp "${RELEASE_DIR}/${SRC_TGZ_FILE}.sha512" "${SVN_STAGING_DIR}/kyuubi-shaded-${RELEASE_TAG}/${SRC_TGZ_FILE}.sha512"
+
+  svn add "${SVN_STAGING_DIR}/kyuubi-shaded-${RELEASE_TAG}"
+
+  echo "Uploading release tarballs to ${SVN_STAGING_REPO}/${RELEASE_TAG}"
+  (
+    cd "${SVN_STAGING_DIR}" && \
+    svn commit --username "${ASF_USERNAME}" --password "${ASF_PASSWORD}" --message "Apache Kyuubi Shaded ${RELEASE_TAG}"
+  )
+  echo "Kyuubi Shaded tarballs uploaded"
+}
+
+upload_nexus_staging() {
+  ${KYUUBI_DIR}/build/mvn clean deploy -DskipTests -Papache-release \
+    -s "${KYUUBI_DIR}/build/release/asf-settings.xml"
+}
+
+finalize_svn() {
+  echo "Moving Kyuubi tarballs to the release directory"
+  svn mv --username "${ASF_USERNAME}" --password "${ASF_PASSWORD}" --no-auth-cache \
+     --message "Apache Kyuubi Shaded ${RELEASE_VERSION}" \
+     "${SVN_STAGING_REPO}/kyuubi-shaded-${RELEASE_TAG}" "${SVN_RELEASE_REPO}/kyuubi-shaded-${RELEASE_VERSION}"
+  echo "Kyuubi Shaded tarballs moved"
+}
+
+if [[ "$1" == "publish" ]]; then
+  package
+  upload_svn_staging
+  upload_nexus_staging
+  exit 0
+fi
+
+if [[ "$1" == "finalize" ]]; then
+  echo "THIS STEP IS IRREVERSIBLE! Make sure the vote has passed and you pick the right RC to finalize."
+  read -p "You must be a PMC member to run this step. Continue? [y/N] " ANSWER
+  if [ "$ANSWER" != "y" ]; then
+    echo "Exiting."
+    exit 1
+  fi
+
+  finalize_svn
+  exit 0
+fi
+
+exit_with_usage
diff --git a/build/release/script/announce.sh b/build/release/script/announce.sh
new file mode 100755
index 0000000..ae39cc8
--- /dev/null
+++ b/build/release/script/announce.sh
@@ -0,0 +1,68 @@
+#!/usr/bin/env bash
+
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+set -o pipefail
+set -e
+
+RELEASE_DIR="$(cd "$(dirname "$0")"/..; pwd)"
+
+######### Please modify the variables ##########
+# release version, e.g. 0.1.0
+release_version=${release_version:-""}
+################################################
+
+if [[ -z $release_version ]]; then
+  echo "Please input release version"
+  exit 1
+fi
+
+echo "Release version: ${release_version}"
+
+RELEASE_TEMP_DIR=${RELEASE_DIR}/tmp
+mkdir -p ${RELEASE_TEMP_DIR}
+ANNOUNCE=${RELEASE_TEMP_DIR}/${release_version}_announce.temp
+
+cat >$ANNOUNCE<<EOF
+Title: [ANNOUNCE] Apache Kyuubi Shaded released ${release_version}
+
+Content:
+Hi all,
+
+The Apache Kyuubi community is pleased to announce that
+Apache Kyuubi Shaded ${release_version} has been released!
+
+The full release notes are available at:
+Release Notes: https://kyuubi.apache.org/release/kyuubi-shaded-${release_version}.html
+
+To learn more about Apache Kyuubi, please see
+https://kyuubi.apache.org/
+
+Kyuubi Resources:
+- Issue: https://github.com/apache/kyuubi/issues
+- Mailing list: dev@kyuubi.apache.org
+
+We would like to thank all contributors of the Kyuubi community
+who made this release possible!
+
+Thanks,
+On behalf of Apache Kyuubi community
+EOF
+
+echo "please Use announce@apache.org, dev@kyuubi.apache.org
+see announce content in $ANNOUNCE"
diff --git a/build/release/script/dev_kyuubi_vote.sh b/build/release/script/dev_kyuubi_vote.sh
new file mode 100755
index 0000000..1ce1bb5
--- /dev/null
+++ b/build/release/script/dev_kyuubi_vote.sh
@@ -0,0 +1,116 @@
+#!/usr/bin/env bash
+
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+set -o pipefail
+set -e
+
+RELEASE_DIR="$(cd "$(dirname "$0")"/..; pwd)"
+
+######### Please modify the variables ##########
+# release version, e.g. v0.1.0
+release_version=${release_version:-""}
+# release candidate number, e.g. rc2
+release_rc_no=${release_rc_no:-""}
+# previous release candidate number, e.g. rc1, could be empty if it is the first vote
+prev_release_rc_no=${prev_release_rc_no:-""}
+# previous release version, e.g. v0.1.0, this is used to generate change log
+prev_release_version=${prev_release_version:-""}
+# staging repository number, check it under https://repository.apache.org/content/repositories
+repo_no=${repo_no:-""}
+################################################
+
+if [[ -z $release_version ]]; then
+  echo "Please input release version"
+  exit 1
+fi
+if [[ -z $release_rc_no ]]; then
+  echo "Please input release rc number"
+  exit 1
+fi
+if [[ -z $prev_release_version ]]; then
+  echo "Please input prev release version which is used to generate change log"
+  exit 1
+fi
+if [[ -z $repo_no ]]; then
+  echo "Please input staging repository number, check it under https://repository.apache.org/content/repositories "
+  exit 1
+fi
+
+release_rc_tag=${release_version}-${release_rc_no}
+git_commit_hash=$(git rev-list -n 1 $release_rc_tag)
+
+echo "Release version: ${release_version}"
+echo "Release candidate number: ${release_rc_no}"
+echo "Previous release candidate number: ${prev_release_rc_no}"
+echo "Staging repository number: ${repo_no}"
+echo "Release candidate tag: ${release_rc_tag}"
+echo "Release candidate tag commit hash: ${git_commit_hash}"
+
+if [[ ! -z "$prev_release_rc_no" ]]; then
+  prev_release_rc_tag=${release_version}-${prev_release_rc_no}
+  change_from_pre_commit="
+The commit list since the ${prev_release_rc_no}:
+https://github.com/apache/kyuubi/compare/${prev_release_rc_tag}...${release_rc_tag}
+"
+fi
+
+RELEASE_TEMP_DIR=${RELEASE_DIR}/tmp
+mkdir -p ${RELEASE_TEMP_DIR}
+DEV_VOTE=${RELEASE_TEMP_DIR}/${release_rc_tag}_dev_vote.temp
+
+cat >${DEV_VOTE}<<EOF
+Title: [VOTE] Release Apache Kyuubi Shaded ${release_version} ${release_rc_no}
+
+Content:
+Hello Apache Kyuubi PMC and Community,
+
+Please vote on releasing the following candidate as
+Apache Kyuubi version ${release_version}.
+
+The VOTE will remain open for at least 72 hours.
+
+[ ] +1 Release this package as Apache Kyuubi ${release_version}
+[ ] +0
+[ ] -1 Do not release this package because ...
+
+To learn more about Apache Kyuubi, please see
+https://kyuubi.apache.org/
+
+The tag to be voted on is ${release_rc_tag} (commit ${git_commit_hash}):
+https://github.com/apache/kyuubi-shaded/tree/${release_rc_tag}
+
+The release files, including signatures, digests, etc. can be found at:
+https://dist.apache.org/repos/dist/dev/kyuubi/kyuubi-shaded-${release_rc_tag}/
+
+Signatures used for Kyuubi RCs can be found in this file:
+https://downloads.apache.org/kyuubi/KEYS
+
+The staging repository for this release can be found at:
+https://repository.apache.org/content/repositories/orgapachekyuubi-${repo_no}/
+${change_from_pre_commit}
+The release note is available in:
+https://github.com/apache/kyuubi-shaded/compare/${prev_release_version}...${release_rc_tag}
+
+Thanks,
+On behalf of Apache Kyuubi community
+EOF
+
+echo "please use dev@kyuubi.apache.com
+see vote content in $DEV_VOTE
+please check all the links and ensure they are available"
diff --git a/build/release/tmpl/dev_kyuubi_cancel_vote.tmpl b/build/release/tmpl/dev_kyuubi_cancel_vote.tmpl
new file mode 100644
index 0000000..8eaa525
--- /dev/null
+++ b/build/release/tmpl/dev_kyuubi_cancel_vote.tmpl
@@ -0,0 +1,29 @@
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+Title: [CANCEL][VOTE] Release Apache Kyuubi Shaded {release_version} {release_rc_no}
+
+Content:
+Hello Apache Kyuubi PMC and Community,
+
+We need to cancel the Apache Kyuubi Shaded {release_rc_no} due to {issue_description}[1],
+and thank everyone who helped vote.
+
+[1] https://github.com/apache/kyuubi-shaded/issues/{issue_number}
+
+Thanks,
+<Release Manager Name>
diff --git a/build/release/tmpl/dev_kyuubi_vote_result.tmpl b/build/release/tmpl/dev_kyuubi_vote_result.tmpl
new file mode 100644
index 0000000..52e733f
--- /dev/null
+++ b/build/release/tmpl/dev_kyuubi_vote_result.tmpl
@@ -0,0 +1,43 @@
+#
+# Licensed to the Apache Software Foundation (ASF) under one or more
+# contributor license agreements.  See the NOTICE file distributed with
+# this work for additional information regarding copyright ownership.
+# The ASF licenses this file to You under the Apache License, Version 2.0
+# (the "License"); you may not use this file except in compliance with
+# the License.  You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+Title: [RESULT][VOTE] Release Apache Kyuubi Shaded {release_version} {release_rc_no}
+
+Content:
+Hello Apache Kyuubi PMC and Community,
+
+The vote closes now as 72hr have passed. The vote PASSES with
+
+(* = binding)
++1:
+- {AA}*
+- {BB}
+- {CC}*
+- {DD}*
+
++0: None
+
+-1: None
+
+The vote thread:
+{dev_kyuubi_vote_mail_address}
+
+Thanks to all who helped with the release! I will be working
+on publishing the artifacts soon.
+
+Thanks,
+On behalf of Apache Kyuubi community